import java.util.concurrent.TimeUnit;
import java.util.concurrent.locks.*;

public class DeadlockDetectionFehlalarm
{
   public static void main( String[] args )
   {
      (new Thread( new DeadlockDetector() )).start();

      // "Ownable Synchronizer" (ab Java 5):
      final Lock lockA = new ReentrantLock();
      final Lock lockB = new ReentrantLock();
      (new Thread( new MeinRunnableMitJava5Lock( lockA, lockB ) )).start();
      (new MeinRunnableMitJava5Lock( lockB, lockA )).run();

      System.out.println( "Fertig." );
      System.exit( 0 );
   }
}

class MeinRunnableMitJava5Lock implements Runnable
{
   Lock lock1, lock2;

   MeinRunnableMitJava5Lock( Lock lock1, Lock lock2 )
   {
      this.lock1 = lock1;
      this.lock2 = lock2;
   }

   @Override
   public void run()
   {
      lock1.lock();
      try {
         Thread.sleep( 500 );
         if( lock2.tryLock( 10, TimeUnit.SECONDS ) )
            lock2.unlock();
      } catch( InterruptedException ex ) {
         ex.printStackTrace();
      } finally {
         lock1.unlock();
      }
   }
}
