import java.lang.management.*;

public class DeadlockDetector implements Runnable
{
   // Fuer Tests auf 1 Sekunde, sonst besser laengere Perioden:
   private static final long PERIOD_TIME_SECONDS = 1;
   private final ThreadMXBean threadMXBean = ManagementFactory.getThreadMXBean();

   @Override
   public void run()
   {
      while( true ) {
         long[] ids = ( threadMXBean.isSynchronizerUsageSupported() )
                      ? threadMXBean.findDeadlockedThreads()
                      : threadMXBean.findMonitorDeadlockedThreads();
         if( ids != null && ids.length > 0 ) {
            for( long id : ids ) {
               ThreadInfo threadInfo = threadMXBean.getThreadInfo( id );
               System.out.println( threadInfo );
            }
         }
         try { Thread.sleep( PERIOD_TIME_SECONDS * 1000 ); } catch( InterruptedException ex ) {/*ok*/}
      }
   }
}
