public class DeadlockKonto
{
   public static void main( String[] args )
   {
      Konto kontoA = new Konto(), kontoB = new Konto();
      (new Thread( new MeinRunnableKto( kontoA, kontoB ) )).start();
      (new Thread( new MeinRunnableKto( kontoB, kontoA ) )).start();
   }
}

class MeinRunnableKto implements Runnable
{
   Konto vonKonto, nachKonto;

   MeinRunnableKto( Konto vonKonto, Konto nachKonto )
   {
      this.vonKonto  = vonKonto;
      this.nachKonto = nachKonto;
   }

   @Override
   public void run()
   {
      int i = 0;
      while( ++i < 10000 ) {
         uebertrageBetrag( i );
         try { Thread.sleep( 1 ); } catch( InterruptedException ex ) {/*ok*/}
      }
   }

   boolean uebertrageBetrag( int betrag )
   {
      synchronized( vonKonto ) {
         synchronized( nachKonto ) {
            System.out.println( Thread.currentThread().getName() + ": " + betrag );
            if( vonKonto.kontoStand < betrag ) return false;
            vonKonto.einauszahlen( -betrag );
            nachKonto.einauszahlen( betrag );
            return true;
         }
      }
   }
}

class Konto
{
   int kontoStand;

   void einauszahlen( int betrag ) { kontoStand += betrag; }
}
