import java.util.*;

// LRU-Cache ("Least recently used")
public final class LruLinkedHashMap<A,V> extends LinkedHashMap<A,V>
{
   private static final long serialVersionUID = 1L;
   private final int maxEntries;

   public LruLinkedHashMap( final int maxEntries )
   {
      super( 16, 0.75f, true );
      this.maxEntries = maxEntries;
   }

   @Override
   protected boolean removeEldestEntry( Map.Entry<A,V> lru )
   {
      return size() > maxEntries;
   }
}
